//
//  TSP.h
//  2004/08/07
//  2004/10/16
//

#ifndef  TSP_h

#include  <math.h>



class TSP
{
private:
	unsigned  N;
	int*  xCoord;
	int*  yCoord;
	double* distances;	// 2-D array
	char*  filename;

public:
	TSP( char* file );

	unsigned  getDistance( const unsigned& first, const unsigned& second )
	{
		int  xDist, yDist;
			
		xDist  =  xCoord[first] - xCoord[second];
		yDist  =  yCoord[first] - yCoord[second];

		return  int( sqrt(double(xDist*xDist + yDist*yDist)) + 0.5 );
	}

	unsigned  getLength(int* array);

	unsigned getN()
	{  return N;  }

	bool  coordCheck();


private:
	unsigned  readN( char* file );
	void  loadCoords( char* file, unsigned N, int* xCoord, int* yCoord );
	void  makeDistances();

};

#define  TSP_h
#endif
