//
//  Tour.h
//  2004/08/07
//  2004/10/29
//


#include  "MyStack.h"
#include  "TSP.h"



class Tour
{
public:
	Tour();
	Tour( const Tour& orig );
	Tour( TSP* instance );
	~Tour();
	Tour&  operator=( const Tour& rhs );

	void  backToBest();
	void  backToBest( const bool& make );

	void  copyTour( Tour* from );

	int  findDifferent( int* other );

	unsigned  getCurrentLength()
	{  return  currentLength; }

	int  getImprovement()
	{  return  improvement; }

	void loadTour(char* file);

	void  makeEdges();

	void  setBest();
	void  setBest( const bool& make );

	void  twoOpt();
	void  twoOpt( int* array );
	void  twoOpt( Tour* other, const double& saga );

	void  update();

	bool  listCheck( int* list );
	void printTour ();
	void printTour(char* file);


private:
	void  makeInsertion();
	void  makeRandom();
	int  extraDistance(const unsigned& first, const unsigned& second, const unsigned& insert);

	void  calculateImprovement();

	bool  validate();

	void  swap( int* array, const unsigned& first, const unsigned& second );

private:
	unsigned  N;	// typically same for each Tour  (not currently static)
	TSP*  tspInstance;

	// TSP solutions stored as permutation sequences
	int*  best;
	int*  current;

	int*  forwardEdge;
	int*  backwardEdge;
	int*  random;

	unsigned  bestLength;
	unsigned  currentLength;
	int       improvement;
	unsigned  edge1, edge2;

	MyStack*  pStack;
};
