//
//  getInitTemp.cpp
//
//  2004/10/16
//


#include  <math.h>

#include  "Tour.h"





//  adaptive temperature-setting section

double  getInitTemp( Tour* sa )
{
//    no backward steps in the first generation
//    just 50 iterations -- don't do too much at temp=0
/* set temperature to allow average backward step with 50% probability */

	double  retVal;

	double  deltaE;

	double  total = 0.0;		// for average
	unsigned  count = 0u;

	for ( unsigned j=0u; j < 50u; j++)
	{
		sa->twoOpt();
		deltaE  =  double(sa->getImprovement());

		if ( deltaE >= 0.0 )
			sa->update();
		else
		{
			total += deltaE;
			count++;
		}
	}
	retVal  =  (total/count) / log(0.5);

	return  retVal;
}