//
//  mtSAGA.cpp
//
//  2004/09/28
//  2004/10/22
//

#include  <windows.h>

#include  <math.h>
#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>

#include  "../Random.h"
#include  "../Tour.h"
#include  "../TSP.h"


DWORD WINAPI  threadCode( LPVOID threadParam );



const unsigned  maxNPE = 16u;		// max number of parallel efforts
						// == max number of threads
unsigned  nThreads = 0u;		// number of threads

						
double  mu;			// cooling parameter
double  common;		// common components parameter

TSP*  pTSP;
char  outFileNameBase[256];


//  command-line arguments
//    0  -  command of invocation
//    1  -  number of "threads"
//    2  -  input file
//    3  -  output file  (not used as originally)
//    4  -  mu
//    5  -  [for SAGA only]
//    6  -  srand() seed

char*  args[] = { "theApp",
  "2", 
  "C:\\q\\dev\\yi\\LIN318.txt",
  "C:\\q\\dev\\yi\\mtSAGAout.txt",
  "0.9",		
  "0.9",
  "1"
};


HANDLE  hEvent1[maxNPE];	// signal temperature-set completion
HANDLE  hEvent2;			// signal thread resumption
HANDLE  hEvent3[maxNPE];	// signal thread completion

CRITICAL_SECTION  cs;		// critical section for copying solutions

Tour  postedSolution[maxNPE];
unsigned  sLength[maxNPE];


int  main( unsigned argc, char* argv[] )
{

	bool  loopExitO = false;
	unsigned  i = 0u;
	unsigned  e = 0u;


// Copy command-line values from argv to args here.
	for ( unsigned a=1u; a<argc; a++ )
		args[a]  =  argv[a];

	nThreads  =  atoi(args[1]);

	strcpy(outFileNameBase,args[3]);

	mu  =  atof(args[4]);
	common  =  atof(args[5]);

	srand( atoi(args[6]) );

	pTSP  =  new TSP(args[2]);	// the problem we are solving


	
	
//  Start threads, and wait for them to set temperatures.

	hEvent2  =  CreateEvent( NULL, 1, 0, NULL );
	if ( !hEvent2 )
		fprintf( stderr, "CreateEvent #2 failed\n" );
	ResetEvent( hEvent2 );

	InitializeCriticalSection( &cs );

	HANDLE  hThread[maxNPE];
	DWORD  threadID[maxNPE];
	for  ( e=0; e<nThreads; e++ )
	{
		sLength[e]  =  ~0u;

		hEvent1[e]  =  CreateEvent( NULL, 1, 0, NULL );
		hEvent3[e]  =  CreateEvent( NULL, 1, 0, NULL );
		if ( !hEvent1[e] || !hEvent3[e] )
			fprintf( stderr, "CreateEvent #1 or #3 failed\n" );
		ResetEvent( hEvent1[e] );
		ResetEvent( hEvent3[e] );

		hThread[e]  =  CreateThread( NULL, 1000000,
			                         threadCode, (void*)e,
									 0, threadID+e );
	}



	WaitForMultipleObjects( nThreads, hEvent1, true, INFINITE );



// Now okay to do the main stuff.
//   We had to allow each thread to get a preliminary result.
//   SetEvent #2 lets them resume.

	SetEvent( hEvent2 );



	WaitForMultipleObjects( nThreads, hEvent3, true, INFINITE );

// Figure out which parallel effort was best.
	unsigned  eBest = 0;
	for  ( e=1; e<nThreads; e++ )
	{
		if  ( sLength[e] < sLength[eBest] )
			eBest  = e;
	}
	printf( "Effort %d was best\n", eBest);



	//  Report results.
	FILE*  writer;
	writer  =  fopen( outFileNameBase, "w" );
	if  ( !writer )
	{
		fprintf( stderr, "*** mtSAGA: unable to open output file ***\n" );
		fprintf( stderr, "      %s\n", outFileNameBase );
	}

	fprintf( writer, "%10d\n",  sLength[eBest] );

	
	fclose( writer );		// good housekeeping

	delete  pTSP;
	return  0;
}
